import _extends from "@babel/runtime/helpers/extends";
import React from 'react';
import PropTypes from 'prop-types';
import clsx from 'clsx';
import { makeStyles } from '@material-ui/core/styles';
import Stepper from "@material-ui/core/esm/Stepper";
import Step from "@material-ui/core/esm/Step";
import StepLabel from "@material-ui/core/esm/StepLabel";
var useStyles = makeStyles(function () {
  return {
    stepper: {
      width: '100%'
    }
  };
});

var WizardNav = function WizardNav(_ref) {
  var StepperProps = _ref.StepperProps,
      stepsInfo = _ref.stepsInfo,
      activeStepIndex = _ref.activeStepIndex;
  var classes = useStyles();
  return /*#__PURE__*/React.createElement(Stepper, _extends({}, StepperProps, {
    className: clsx(classes.stepper, StepperProps.className),
    activeStep: activeStepIndex
  }), stepsInfo.map(function (_ref2, idx) {
    var title = _ref2.title,
        label = _ref2.label,
        StepLabelProps = _ref2.StepLabelProps,
        StepProps = _ref2.StepProps;
    return /*#__PURE__*/React.createElement(Step, _extends({}, StepProps, {
      key: idx
    }), /*#__PURE__*/React.createElement(StepLabel, StepLabelProps, title || label));
  }));
};

WizardNav.propTypes = {
  StepperProps: PropTypes.object,
  stepsInfo: PropTypes.arrayOf(PropTypes.shape({
    title: PropTypes.node,
    label: PropTypes.node,
    StepLabelProps: PropTypes.object,
    StepProps: PropTypes.object
  })),
  activeStepIndex: PropTypes.number
};
WizardNav.defaultProps = {
  StepperProps: {}
};
export default WizardNav;